20334: Batch permission updates during link dedup migration.
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepbalance"
33   echo >&2 "                                                keepstore"
34   echo >&2 "                                                keepweb"
35   echo >&2 "                                                monitoring"
36   echo >&2 "                                                shell"
37   echo >&2 "                                                webshell"
38   echo >&2 "                                                websocket"
39   echo >&2 "                                                workbench"
40   echo >&2 "                                                workbench2"
41   echo >&2 "                                              Defaults to applying them all"
42   echo >&2 "  -h, --help                                  Display this help and exit"
43   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
44   echo >&2 "                                              This parameter does not perform any installation at all. It's"
45   echo >&2 "                                              intended to give you a parsed set of configuration files so"
46   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
47   echo >&2 "                                              It"
48   echo >&2 "                                                - parses the pillar and states templates,"
49   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
50   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
51   echo >&2 "                                                  for the selected role(s)"
52   echo >&2 "                                                - writes the resulting files into <dest_dir>"
53   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
54   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
55   echo >&2
56 }
57
58 arguments() {
59   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
60   if ! which getopt > /dev/null; then
61     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
62     exit 1
63   fi
64
65   TEMP=$(getopt -o c:dhp:r:tv \
66     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
67     -n "${0}" -- "${@}")
68
69   if [ ${?} != 0 ];
70     then echo "Please check the parameters you entered and re-run again"
71     exit 1
72   fi
73   # Note the quotes around `$TEMP': they are essential!
74   eval set -- "$TEMP"
75
76   while [ ${#} -ge 1 ]; do
77     case ${1} in
78       -c | --config)
79         CONFIG_FILE=${2}
80         shift 2
81         ;;
82       -d | --debug)
83         LOG_LEVEL="debug"
84         shift
85         set -x
86         ;;
87       --dump-config)
88         if [[ ${2} = /* ]]; then
89           DUMP_SALT_CONFIG_DIR=${2}
90         else
91           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
92         fi
93         ## states
94         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
95         ## formulas
96         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
97         ## pillars
98         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
99         ## tests
100         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
101         DUMP_CONFIG="yes"
102         shift 2
103         ;;
104       --development)
105         DEV_MODE="yes"
106         shift 1
107         ;;
108       -r | --roles)
109         for i in ${2//,/ }
110           do
111             # Verify the role exists
112             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher,monitoring" == *"$i"* ]]; then
113               echo "The role '${i}' is not a valid role"
114               usage
115               exit 1
116             fi
117             ROLES="${ROLES} ${i}"
118           done
119           shift 2
120         ;;
121       -t | --test)
122         TEST="yes"
123         shift
124         ;;
125       -v | --vagrant)
126         VAGRANT="yes"
127         shift
128         ;;
129       --)
130         shift
131         break
132         ;;
133       *)
134         usage
135         exit 1
136         ;;
137     esac
138   done
139 }
140
141 copy_custom_cert() {
142   cert_dir=${1}
143   cert_name=${2}
144
145   mkdir -p --mode=0700 /srv/salt/certs
146
147   if [ -f ${cert_dir}/${cert_name}.crt ]; then
148     install --mode=0600 ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
149   else
150     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
151     exit 1
152   fi
153   if [ -f ${cert_dir}/${cert_name}.key ]; then
154     install --mode=0600 ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
155   else
156     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
157     exit 1
158   fi
159 }
160
161 DEV_MODE="no"
162 CONFIG_FILE="${SCRIPT_DIR}/local.params"
163 CONFIG_DIR="local_config_dir"
164 DUMP_CONFIG="no"
165 LOG_LEVEL="info"
166 CONTROLLER_EXT_SSL_PORT=443
167 TESTS_DIR="tests"
168
169 NGINX_INSTALL_SOURCE="install_from_repo"
170
171 CLUSTER=""
172 DOMAIN=""
173
174 # Hostnames/IPs used for single-host deploys
175 IP_INT="127.0.1.1"
176
177 # Initial user setup
178 INITIAL_USER=""
179 INITIAL_USER_EMAIL=""
180 INITIAL_USER_PASSWORD=""
181
182 CONTROLLER_EXT_SSL_PORT=8000
183 KEEP_EXT_SSL_PORT=25101
184 # Both for collections and downloads
185 KEEPWEB_EXT_SSL_PORT=9002
186 WEBSHELL_EXT_SSL_PORT=4202
187 WEBSOCKET_EXT_SSL_PORT=8002
188 WORKBENCH1_EXT_SSL_PORT=443
189 WORKBENCH2_EXT_SSL_PORT=3001
190
191 SSL_MODE="self-signed"
192 USE_LETSENCRYPT_ROUTE53="no"
193 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
194
195 GRAFANA_DASHBOARDS_DIR="${SCRIPT_DIR}/local_config_dir/dashboards"
196
197 ## These are ARVADOS-related parameters
198 # For a stable release, change RELEASE "production" and VERSION to the
199 # package version (including the iteration, e.g. X.Y.Z-1) of the
200 # release.
201 # The "local.params.example.*" files already set "RELEASE=production"
202 # to deploy  production-ready packages
203 RELEASE="development"
204 VERSION="latest"
205
206 # These are arvados-formula-related parameters
207 # An arvados-formula tag. For a stable release, this should be a
208 # branch name (e.g. X.Y-dev) or tag for the release.
209 # ARVADOS_TAG="2.2.0"
210 # BRANCH="main"
211
212 # We pin the salt version to avoid potential incompatibilities when a new
213 # stable version is released.
214 SALT_VERSION="3004"
215
216 # Other formula versions we depend on
217 #POSTGRES_TAG="v0.44.0"
218 #POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
219 POSTGRES_TAG="0.45.0-bugfix327"
220 POSTGRES_URL="https://github.com/arvados/postgres-formula.git"
221 NGINX_TAG="v2.8.1"
222 DOCKER_TAG="v2.4.2"
223 LOCALE_TAG="v0.3.4"
224 LETSENCRYPT_TAG="v2.1.0"
225 LOGROTATE_TAG="v0.14.0"
226 PROMETHEUS_TAG="v5.6.5"
227 GRAFANA_TAG="v3.1.3"
228
229 # Salt's dir
230 DUMP_SALT_CONFIG_DIR=""
231 ## states
232 S_DIR="/srv/salt"
233 ## formulas
234 F_DIR="/srv/formulas"
235 ## pillars
236 P_DIR="/srv/pillars"
237 ## tests
238 T_DIR="/tmp/cluster_tests"
239
240 arguments ${@}
241
242 declare -A NODES
243
244 if [ -s ${CONFIG_FILE} ]; then
245   source ${CONFIG_FILE}
246 else
247   echo >&2 "You don't seem to have a config file with initial values."
248   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
249   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
250   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
251   exit 1
252 fi
253
254 if [ ! -d ${CONFIG_DIR} ]; then
255   echo >&2 "You don't seem to have a config directory with pillars and states."
256   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
257   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
258   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
259   exit 1
260 fi
261
262 if grep -rni 'fixme' ${CONFIG_FILE} ${CONFIG_DIR} ; then
263   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
264   echo >&2 "Please, fix them and re-run the provision script."
265   exit 1
266 fi
267
268 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
269   echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
270   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
271   exit 1
272 fi
273
274 # Only used in single_host/single_name deploys
275 if [ ! -z "${HOSTNAME_EXT}" ] ; then
276   # We need to add some extra control vars to manage a single certificate vs. multiple
277   USE_SINGLE_HOSTNAME="yes"
278   # Make sure that the value configured as IP_INT is a real IP on the system.
279   # If we don't error out early here when there is a mismatch, the formula will
280   # fail with hard to interpret nginx errors later on.
281   ip addr list |grep "${IP_INT}/" >/dev/null
282   if [[ $? -ne 0 ]]; then
283     echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
284     exit 1
285   fi
286 else
287   USE_SINGLE_HOSTNAME="no"
288   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
289   # conditionals
290   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
291 fi
292
293 if [ "${DUMP_CONFIG}" = "yes" ]; then
294   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
295 else
296   # Install a few dependency packages
297   # First, let's figure out the OS we're working on
298   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
299   echo "Detected distro: ${OS_ID}"
300
301   case ${OS_ID} in
302     "centos")
303       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
304       sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
305       setenforce permissive
306       yum install -y  curl git jq
307       ;;
308     "debian"|"ubuntu")
309       # Wait 2 minutes for any apt locks to clear
310       # This option is supported from apt 1.9.1 and ignored in older apt versions.
311       # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
312       DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
313       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
314       ;;
315   esac
316
317   if which salt-call; then
318     echo "Salt already installed"
319   else
320     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
321     sh /tmp/bootstrap_salt.sh -XdfP -x python3 stable ${SALT_VERSION}
322     /bin/systemctl stop salt-minion.service
323     /bin/systemctl disable salt-minion.service
324   fi
325
326   # Set salt to masterless mode
327   cat > /etc/salt/minion << EOFSM
328 failhard: "True"
329
330 file_client: local
331 file_roots:
332   base:
333     - ${S_DIR}
334     - ${F_DIR}/*
335
336 pillar_roots:
337   base:
338     - ${P_DIR}
339 EOFSM
340 fi
341
342 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
343
344 # Get the formula and dependencies
345 cd ${F_DIR} || exit 1
346 echo "Cloning formulas"
347 test -d docker && ( cd docker && git fetch ) \
348   || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
349 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
350
351 echo "...locale"
352 test -d locale && ( cd locale && git fetch ) \
353   || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
354 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
355
356 echo "...nginx"
357 test -d nginx && ( cd nginx && git fetch ) \
358   || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
359 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
360
361 echo "...postgres"
362 test -d postgres && ( cd postgres && git fetch ) \
363   || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
364 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" )
365
366 echo "...prometheus"
367 test -d prometheus && ( cd prometheus && git fetch ) \
368   || git clone --quiet https://github.com/saltstack-formulas/prometheus-formula.git ${F_DIR}/prometheus
369 ( cd prometheus && git checkout --quiet tags/"${PROMETHEUS_TAG}" )
370
371 echo "...grafana"
372 test -d grafana && ( cd grafana && git fetch ) \
373   || git clone --quiet https://github.com/saltstack-formulas/grafana-formula.git ${F_DIR}/grafana
374 ( cd grafana && git checkout --quiet "${GRAFANA_TAG}" )
375
376 echo "...letsencrypt"
377 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
378   || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
379 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
380
381 echo "...logrotate"
382 test -d logrotate && ( cd logrotate && git fetch ) \
383   || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
384 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
385
386 echo "...arvados"
387 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
388
389 # If we want to try a specific branch of the formula
390 if [ "x${BRANCH}" != "x" ]; then
391   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
392 elif [ "x${ARVADOS_TAG}" != "x" ]; then
393   ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
394 fi
395
396 if [ "x${VAGRANT}" = "xyes" ]; then
397   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
398   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
399   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
400 else
401   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
402   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
403   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
404 fi
405
406 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
407
408 echo "Writing pillars and states"
409
410 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
411 # to ease deployment for newcomers
412 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
413   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
414   exit 1
415 fi
416 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
417   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
418        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
419        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
420        s#__CLUSTER__#${CLUSTER}#g;
421        s#__DOMAIN__#${DOMAIN}#g;
422        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
423        s#__IP_INT__#${IP_INT}#g;
424        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
425        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
426        s#__INITIAL_USER__#${INITIAL_USER}#g;
427        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
428        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
429        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
430        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
431        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
432        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
433        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
434        s#__RELEASE__#${RELEASE}#g;
435        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
436        s#__VERSION__#${VERSION}#g;
437        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
438        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
439        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
440        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
441        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
442        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
443        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
444        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
445        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
446        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
447        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
448        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
449        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
450        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
451        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
452        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
453        s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
454        s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION}#g;
455        s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g;
456        s#__MONITORING_USERNAME__#${MONITORING_USERNAME}#g;
457        s#__MONITORING_EMAIL__#${MONITORING_EMAIL}#g;
458        s#__MONITORING_PASSWORD__#${MONITORING_PASSWORD}#g" \
459   "${f}" > "${P_DIR}"/$(basename "${f}")
460 done
461
462 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
463   echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
464   if [ "x${TEST}" = "xyes" ]; then
465     echo "WARNING: Disabling tests for this installation."
466   fi
467   TEST="no"
468 else
469   mkdir -p ${T_DIR}
470   # Replace cluster and domain name in the test files
471   for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
472     FILTERS="s#__CLUSTER__#${CLUSTER}#g;
473          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
474          s#__DOMAIN__#${DOMAIN}#g;
475          s#__IP_INT__#${IP_INT}#g;
476          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
477          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
478          s#__INITIAL_USER__#${INITIAL_USER}#g;
479          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
480          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
481     if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
482       FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
483          $FILTERS"
484     fi
485     sed "$FILTERS" \
486       "${f}" > ${T_DIR}/$(basename "${f}")
487   done
488   chmod 755 ${T_DIR}/run-test.sh
489 fi
490
491 # Replace helper state files that differ from the formula's examples
492 if [ -d "${SOURCE_STATES_DIR}" ]; then
493   mkdir -p "${F_DIR}"/extra/extra
494   rm -f "${F_DIR}"/extra/extra/*
495
496   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
497     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
498          s#__CLUSTER__#${CLUSTER}#g;
499          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
500          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
501          s#__DOMAIN__#${DOMAIN}#g;
502          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
503          s#__IP_INT__#${IP_INT}#g;
504          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
505          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
506          s#__INITIAL_USER__#${INITIAL_USER}#g;
507          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
508          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
509          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
510          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
511          s#__RELEASE__#${RELEASE}#g;
512          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
513          s#__VERSION__#${VERSION}#g;
514          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
515          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
516          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
517          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
518          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
519          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
520          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
521          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
522          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
523          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
524          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
525          s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
526          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
527          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
528          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
529          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
530          s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
531          s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION}#g;
532          s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g;
533          s#__MONITORING_USERNAME__#${MONITORING_USERNAME}#g;
534          s#__MONITORING_EMAIL__#${MONITORING_EMAIL}#g;
535          s#__MONITORING_PASSWORD__#${MONITORING_PASSWORD}#g" \
536     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
537   done
538 fi
539
540 # Now, we build the SALT states/pillars trees
541 # As we need to separate both states and pillars in case we want specific
542 # roles, we iterate on both at the same time
543
544 # States
545 cat > ${S_DIR}/top.sls << EOFTSLS
546 base:
547   '*':
548     - locale
549 EOFTSLS
550
551 # Pillars
552 cat > ${P_DIR}/top.sls << EOFPSLS
553 base:
554   '*':
555     - locale
556     - arvados
557 EOFPSLS
558
559 # States, extra states
560 if [ -d "${F_DIR}"/extra/extra ]; then
561   SKIP_SNAKE_OIL="snakeoil_certs"
562
563   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
564     # In dev mode, we create some snake oil certs that we'll
565     # use as CUSTOM_CERTS, so we don't skip the states file.
566     # Same when using self-signed certificates.
567     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
568   fi
569   for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
570   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
571   done
572   # Use byo or self-signed certificates
573   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
574     mkdir -p "${F_DIR}"/extra/extra/files
575   fi
576 fi
577
578 # If we want specific roles for a node, just add the desired states
579 # and its dependencies
580 if [ -z "${ROLES}" ]; then
581   # States
582   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
583   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
584     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
585       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
586     fi
587     grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
588   else
589     mkdir -p --mode=0700 /srv/salt/certs
590     if [ "${SSL_MODE}" = "bring-your-own" ]; then
591       # Copy certs to formula extra/files
592       install --mode=0600 ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
593       # We add the custom_certs state
594       grep -q "custom_certs" ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
595       if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
596         grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo "    - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
597       fi
598     fi
599     # In self-signed mode, the certificate files will be created and put in the
600     # destination directory by the snakeoil_certs.sls state file
601   fi
602
603   echo "    - postgres" >> ${S_DIR}/top.sls
604   echo "    - logrotate" >> ${S_DIR}/top.sls
605   echo "    - docker.software" >> ${S_DIR}/top.sls
606   echo "    - arvados" >> ${S_DIR}/top.sls
607   echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
608   echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
609   echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
610
611   # Pillars
612   echo "    - docker" >> ${P_DIR}/top.sls
613   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
614   echo "    - logrotate_api" >> ${P_DIR}/top.sls
615   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
616   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
617   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
618   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
619   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
620   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
621   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
622   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
623   echo "    - logrotate_wb1" >> ${P_DIR}/top.sls
624   echo "    - postgresql" >> ${P_DIR}/top.sls
625
626   # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
627   NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
628   sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
629
630   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
631     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
632       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
633     fi
634     grep -q "letsencrypt" ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
635
636     hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
637     if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
638       hosts+=("download" "collections")
639     else
640       hosts+=("keepweb")
641     fi
642
643     for c in "${hosts[@]}"; do
644       # Are we in a single-host-single-hostname env?
645       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
646         # Are we in a single-host-single-hostname env?
647         CERT_NAME=${HOSTNAME_EXT}
648       else
649         # We are in a multiple-hostnames env
650         CERT_NAME=${c}.${CLUSTER}.${DOMAIN}
651       fi
652
653       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
654       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
655               s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
656               s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
657       ${P_DIR}/nginx_${c}_configuration.sls
658     done
659   else
660     # Use custom certs (either dev mode or prod)
661     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
662     # And add the certs in the custom_certs pillar
663     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
664     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
665
666     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
667       # Are we in a single-host-single-hostname env?
668       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
669         # Are we in a single-host-single-hostname env?
670         CERT_NAME=${HOSTNAME_EXT}
671       else
672         # We are in a multiple-hostnames env
673         CERT_NAME=${c}
674       fi
675
676       if [[ "$SSL_MODE" == "bring-your-own" ]]; then
677         copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
678       fi
679
680       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
681
682       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
683       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
684               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
685               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
686       ${P_DIR}/nginx_${c}_configuration.sls
687     done
688   fi
689 else
690   # If we add individual roles, make sure we add the repo first
691   echo "    - arvados.repo" >> ${S_DIR}/top.sls
692   # We add the extra_custom_certs state
693   grep -q "extra.custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
694   if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
695     grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo "    - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
696   fi
697
698   # And we add the basic part for the certs pillar
699   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
700     # And add the certs in the custom_certs pillar
701     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
702     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
703     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
704   fi
705
706   # Prometheus state on all nodes due to the node exporter below
707   grep -q "\- prometheus$" ${S_DIR}/top.sls || echo "    - prometheus" >> ${S_DIR}/top.sls
708   # Prometheus node exporter pillar
709   grep -q "prometheus_node_exporter" ${P_DIR}/top.sls || echo "    - prometheus_node_exporter" >> ${P_DIR}/top.sls
710
711   for R in ${ROLES}; do
712     case "${R}" in
713       "database")
714         # States
715         grep -q "\- postgres$" ${S_DIR}/top.sls || echo "    - postgres" >> ${S_DIR}/top.sls
716         grep -q "extra.prometheus_pg_exporter" ${S_DIR}/top.sls || echo "    - extra.prometheus_pg_exporter" >> ${S_DIR}/top.sls
717         # Pillars
718         grep -q "postgresql" ${P_DIR}/top.sls || echo "    - postgresql" >> ${P_DIR}/top.sls
719         grep -q "prometheus_pg_exporter" ${P_DIR}/top.sls || echo "    - prometheus_pg_exporter" >> ${P_DIR}/top.sls
720       ;;
721       "monitoring")
722         ### Support files ###
723         GRAFANA_DASHBOARDS_DEST_DIR=/srv/salt/dashboards
724         mkdir -p "${GRAFANA_DASHBOARDS_DEST_DIR}"
725         rm -f "${GRAFANA_DASHBOARDS_DEST_DIR}"/*
726         # "ArvadosPromDataSource" is the hardcoded UID for Prometheus' datasource
727         # in Grafana.
728         for f in $(ls "${GRAFANA_DASHBOARDS_DIR}"/*.json); do
729           sed 's#${DS_PROMETHEUS}#ArvadosPromDataSource#g' \
730           "${f}" > "${GRAFANA_DASHBOARDS_DEST_DIR}"/$(basename "${f}")
731         done
732
733         ### States ###
734         grep -q "\- nginx$" ${S_DIR}/top.sls || echo "    - nginx" >> ${S_DIR}/top.sls
735         grep -q "extra.nginx_prometheus_configuration" ${S_DIR}/top.sls || echo "    - extra.nginx_prometheus_configuration" >> ${S_DIR}/top.sls
736
737         grep -q "\- grafana$" ${S_DIR}/top.sls || echo "    - grafana" >> ${S_DIR}/top.sls
738         grep -q "extra.grafana_datasource" ${S_DIR}/top.sls || echo "    - extra.grafana_datasource" >> ${S_DIR}/top.sls
739         grep -q "extra.grafana_dashboards" ${S_DIR}/top.sls || echo "    - extra.grafana_dashboards" >> ${S_DIR}/top.sls
740         grep -q "extra.grafana_admin_user" ${S_DIR}/top.sls || echo "    - extra.grafana_admin_user" >> ${S_DIR}/top.sls
741
742         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
743           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
744           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
745             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
746           fi
747         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
748           for SVC in grafana prometheus; do
749             copy_custom_cert ${CUSTOM_CERTS_DIR} ${SVC}
750           done
751         fi
752         ### Pillars ###
753         grep -q "prometheus_server" ${P_DIR}/top.sls || echo "    - prometheus_server" >> ${P_DIR}/top.sls
754         grep -q "grafana" ${P_DIR}/top.sls || echo "    - grafana" >> ${P_DIR}/top.sls
755         for SVC in grafana prometheus; do
756           grep -q "nginx_${SVC}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${SVC}_configuration" >> ${P_DIR}/top.sls
757         done
758         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
759           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
760           for SVC in grafana prometheus; do
761             grep -q "letsencrypt_${SVC}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${SVC}_configuration" >> ${P_DIR}/top.sls
762             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${SVC}.${CLUSTER}.${DOMAIN}*/g;
763                     s#__CERT_PEM__#/etc/letsencrypt/live/${SVC}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
764                     s#__CERT_KEY__#/etc/letsencrypt/live/${SVC}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
765             ${P_DIR}/nginx_${SVC}_configuration.sls
766           done
767           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
768             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
769           fi
770         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
771           grep -q "ssl_key_encrypted" ${P_DIR}/top.sls || echo "    - ssl_key_encrypted" >> ${P_DIR}/top.sls
772           for SVC in grafana prometheus; do
773             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${SVC}.pem/g;
774                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${SVC}.pem#g;
775                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${SVC}.key#g" \
776               ${P_DIR}/nginx_${SVC}_configuration.sls
777             grep -q ${SVC} ${P_DIR}/extra_custom_certs.sls || echo "  - ${SVC}" >> ${P_DIR}/extra_custom_certs.sls
778           done
779         fi
780       ;;
781       "api")
782         # States
783         grep -q "    - logrotate" ${S_DIR}/top.sls || echo "    - logrotate" >> ${S_DIR}/top.sls
784         if grep -q "    - nginx.*$" ${S_DIR}/top.sls; then
785           sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
786         else
787           echo "    - nginx.passenger" >> ${S_DIR}/top.sls
788         fi
789         echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
790         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
791         ### after it. So we add this here as we are, after all, sharing the host for api and controller
792         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
793           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
794             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
795           fi
796           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
797         else
798           # Use custom certs
799           if [ "${SSL_MODE}" = "bring-your-own" ]; then
800             copy_custom_cert ${CUSTOM_CERTS_DIR} controller
801           fi
802           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
803         fi
804         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
805         # Pillars
806         grep -q "logrotate_api" ${P_DIR}/top.sls            || echo "    - logrotate_api" >> ${P_DIR}/top.sls
807         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
808         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
809         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
810         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
811
812         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
813         NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
814         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
815       ;;
816       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
817         # States
818         if [ "${R}" = "workbench" ]; then
819           grep -q "    - logrotate" ${S_DIR}/top.sls || echo "    - logrotate" >> ${S_DIR}/top.sls
820           NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
821           if grep -q "    - nginx$" ${S_DIR}/top.sls; then
822             sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
823           else
824             echo "    - nginx.passenger" >> ${S_DIR}/top.sls
825           fi
826         else
827           grep -q "\- nginx$" ${S_DIR}/top.sls || echo "    - nginx" >> ${S_DIR}/top.sls
828         fi
829         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
830           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
831             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
832           fi
833           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
834         else
835           # Use custom certs, special case for keepweb
836           if [ ${R} = "keepweb" ]; then
837             if [ "${SSL_MODE}" = "bring-your-own" ]; then
838               copy_custom_cert ${CUSTOM_CERTS_DIR} download
839               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
840             fi
841           else
842             if [ "${SSL_MODE}" = "bring-your-own" ]; then
843               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
844             fi
845           fi
846         fi
847         # webshell role is just a nginx vhost, so it has no state
848         if [ "${R}" != "webshell" ]; then
849           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
850         fi
851         # Pillars
852         if [ "${R}" = "workbench" ]; then
853           grep -q "logrotate_wb1" ${P_DIR}/top.sls || echo "    - logrotate_wb1" >> ${P_DIR}/top.sls
854         fi
855         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
856         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
857         # Special case for keepweb
858         if [ ${R} = "keepweb" ]; then
859           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
860           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
861         fi
862
863         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
864           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
865             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
866           fi
867           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
868           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
869
870           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
871           # Special case for keepweb
872           if [ ${R} = "keepweb" ]; then
873             for kwsub in download collections; do
874               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
875                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
876                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
877               ${P_DIR}/nginx_${kwsub}_configuration.sls
878             done
879           else
880             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
881                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
882                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
883             ${P_DIR}/nginx_${R}_configuration.sls
884           fi
885         else
886           grep -q "ssl_key_encrypted" ${P_DIR}/top.sls || echo "    - ssl_key_encrypted" >> ${P_DIR}/top.sls
887           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
888           # Special case for keepweb
889           if [ ${R} = "keepweb" ]; then
890             for kwsub in download collections; do
891               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
892                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
893                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
894               ${P_DIR}/nginx_${kwsub}_configuration.sls
895               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
896             done
897           else
898             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
899                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
900                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
901             ${P_DIR}/nginx_${R}_configuration.sls
902             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
903           fi
904         fi
905         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
906         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
907       ;;
908       "shell")
909         # States
910         echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
911         echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
912         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
913         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
914         # Pillars
915         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
916       ;;
917       "dispatcher" | "keepbalance" | "keepstore")
918         # States
919         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
920         # Pillars
921         # ATM, no specific pillar needed
922       ;;
923       *)
924         echo "Unknown role ${R}"
925         exit 1
926       ;;
927     esac
928   done
929 fi
930
931 if [ "${DUMP_CONFIG}" = "yes" ]; then
932   # We won't run the rest of the script because we're just dumping the config
933   exit 0
934 fi
935
936 # Now run the install
937 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
938
939 # Finally, make sure that /etc/hosts is not overwritten on reboot
940 if [ -d /etc/cloud/cloud.cfg.d ]; then
941   # TODO: will this work on CentOS?
942   sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
943 fi
944
945 # Leave a copy of the Arvados CA so the user can copy it where it's required
946 if [ "${SSL_MODE}" = "self-signed" ]; then
947   echo "Copying the Arvados CA certificate '${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
948   if [ "x${VAGRANT}" = "xyes" ]; then
949     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
950   else
951     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt
952   fi
953 fi
954
955 if [ "x${VAGRANT}" = "xyes" ]; then
956     # If running in a vagrant VM, also add default user to docker group
957     echo "Adding the vagrant user to the docker group"
958     usermod -a -G docker vagrant
959 fi
960
961 # Test that the installation finished correctly
962 if [ "x${TEST}" = "xyes" ]; then
963   cd ${T_DIR}
964   # If we use RVM, we need to run this with it, or most ruby commands will fail
965   RVM_EXEC=""
966   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
967     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
968   fi
969   ${RVM_EXEC} ./run-test.sh
970 fi